using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ClassAbilityPriorityManager : MonoBehaviour
{
    public List<ClassAbilityConditionManager> abilityPriorityList = new List<ClassAbilityConditionManager>();

    RiftPlayer player;

    private void Awake()
    {
        player = GetComponentInParent<RiftPlayer>();
    }

    public BaseAbility GetHighestPriorityAvailableAbility()
    {
        for (int i = 0; i < abilityPriorityList.Count; i++)
        {
            if (abilityPriorityList[i].CanCastAbility(player))
                return abilityPriorityList[i].ability;
        }

        return null;
    }
}
